GDCM: gdcm::RLECodec Class Reference

GDCM 3.2.8

Public Member Functions | Protected Member Functions | Friends | List of all members
gdcm::RLECodec Class Reference

Class to do RLE. More...

`#include <gdcmRLECodec.h>`

Inheritance diagram for gdcm::RLECodec:
[legend]
Collaboration diagram for gdcm::RLECodec:
[legend]

## Public Member Functions
| RLECodec ()
| ~RLECodec () override
bool | CanCode (TransferSyntax const &ts) const override
| Return whether this coder support this transfer syntax (can code it).
bool | CanDecode (TransferSyntax const &ts) const override
| Return whether this decoder support this transfer syntax (can decode it).
ImageCodec * | Clone () const override
bool | Code (DataElement const &in, DataElement &out) override
| Code.
bool | Decode (DataElement const &is, DataElement &os) override
| Decode.
unsigned long | GetBufferLength () const
bool | GetHeaderInfo (std::istream &is, TransferSyntax &ts) override
void | SetBufferLength (unsigned long l)
void | SetLength (unsigned long l)
Public Member Functions inherited from gdcm::ImageCodec
| ImageCodec ()
| ~ImageCodec () override
bool | CleanupUnusedBits (char *data, size_t datalen)
const unsigned int * | GetDimensions () const
bool | GetLossyFlag () const
const LookupTable & | GetLUT () const
bool | GetNeedByteSwap () const
unsigned int | GetNumberOfDimensions () const
const PhotometricInterpretation & | GetPhotometricInterpretation () const
PixelFormat & | GetPixelFormat ()
const PixelFormat & | GetPixelFormat () const
unsigned int | GetPlanarConfiguration () const
bool | IsLossy () const
void | SetDimensions (const std::vector< unsigned int > &d)
void | SetDimensions (const unsigned int d[3])
void | SetLossyFlag (bool l)
void | SetLUT (LookupTable const &lut)
void | SetNeedByteSwap (bool b)
void | SetNeedOverlayCleanup (bool b)
void | SetNumberOfDimensions (unsigned int dim)
void | SetPhotometricInterpretation (PhotometricInterpretation const &pi)
virtual void | SetPixelFormat (PixelFormat const &pf)
void | SetPlanarConfiguration (unsigned int pc)
Public Member Functions inherited from gdcm::Coder
virtual | ~Coder ()=default
Public Member Functions inherited from gdcm::Decoder
virtual | ~Decoder ()=default

## Protected Member Functions
bool | AppendFrameEncode (std::ostream &out, const char *data, size_t datalen) override
bool | AppendRowEncode (std::ostream &out, const char *data, size_t datalen) override
bool | DecodeByStreams (std::istream &is, std::ostream &os) override
bool | DecodeExtent (char *buffer, unsigned int XMin, unsigned int XMax, unsigned int YMin, unsigned int YMax, unsigned int ZMin, unsigned int ZMax, std::istream &is)
bool | IsFrameEncoder () override
bool | IsRowEncoder () override
bool | StartEncode (std::ostream &) override
bool | StopEncode (std::ostream &) override
Protected Member Functions inherited from gdcm::ImageCodec
bool | DoByteSwap (std::istream &is_, std::ostream &os)
bool | DoInvertMonochrome (std::istream &is_, std::ostream &os)
bool | DoOverlayCleanup (std::istream &is_, std::ostream &os)
bool | DoPaddedCompositePixelCode (std::istream &is_, std::ostream &os)
bool | DoPlanarConfiguration (std::istream &is_, std::ostream &os)
bool | DoSimpleCopy (std::istream &is_, std::ostream &os)
bool | DoYBR (std::istream &is_, std::ostream &os)
bool | DoYBRFull422 (std::istream &is_, std::ostream &os)
virtual bool | IsValid (PhotometricInterpretation const &pi)
Protected Member Functions inherited from gdcm::Coder
virtual bool | InternalCode (const char *bv, unsigned long len, std::ostream &os)

## Friends
class | ImageRegionReader

## Additional Inherited Members
Protected Types inherited from gdcm::ImageCodec
typedef SmartPointer< LookupTable > | LUTPtr
Protected Attributes inherited from gdcm::ImageCodec
unsigned int | Dimensions [3]
bool | LossyFlag
LUTPtr | LUT
bool | NeedByteSwap
bool | NeedOverlayCleanup
unsigned int | NumberOfDimensions
PixelFormat | PF
PhotometricInterpretation | PI
unsigned int | PlanarConfiguration
bool | RequestPaddedCompositePixelCode
bool | RequestPlanarConfiguration

## Detailed Description

Class to do RLE.

Note
  ANSI X3.9 A.4.2 RLE Compression Annex G defines a RLE Compression Transfer Syntax. This transfer Syntax is identified by the UID value "1.2.840.10008.1.2.5". If the object allows multi-frame images in the pixel data field, then each frame shall be encoded separately. Each frame shall be encoded in one and only one Fragment (see PS 3.5.8.2).

## Constructor & Destructor Documentation

## ◆ RLECodec()

gdcm::RLECodec::RLECodec | ( |  | ) |

## ◆ ~RLECodec()

gdcm::RLECodec::~RLECodec | ( |  | ) |
| override

## Member Function Documentation

## ◆ AppendFrameEncode()

bool gdcm::RLECodec::AppendFrameEncode | ( | std::ostream & | out,
|  | const char * | data,
|  | size_t | datalen )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ AppendRowEncode()

bool gdcm::RLECodec::AppendRowEncode | ( | std::ostream & | out,
|  | const char * | data,
|  | size_t | datalen )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ CanCode()

bool gdcm::RLECodec::CanCode | ( | TransferSyntax const & |  | ) | const
| overridevirtual

Return whether this coder support this transfer syntax (can code it).

Reimplemented from gdcm::ImageCodec.

## ◆ CanDecode()

bool gdcm::RLECodec::CanDecode | ( | TransferSyntax const & |  | ) | const
| overridevirtual

Return whether this decoder support this transfer syntax (can decode it).

Reimplemented from gdcm::ImageCodec.

## ◆ Clone()

ImageCodec * gdcm::RLECodec::Clone | ( |  | ) | const
| overridevirtual

Implements gdcm::ImageCodec.

References gdcm::ImageCodec::ImageCodec().

## ◆ Code()

bool gdcm::RLECodec::Code | ( | DataElement const & | in_,
|  | DataElement & | out_ )
| overridevirtual

Code.

Reimplemented from gdcm::Coder.

## ◆ Decode()

bool gdcm::RLECodec::Decode | ( | DataElement const & | ,
|  | DataElement & | )
| overridevirtual

Decode.

Reimplemented from gdcm::ImageCodec.

## ◆ DecodeByStreams()

bool gdcm::RLECodec::DecodeByStreams | ( | std::istream & | is,
|  | std::ostream & | os )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ DecodeExtent()

bool gdcm::RLECodec::DecodeExtent | ( | char * | buffer,
|  | unsigned int | XMin,
|  | unsigned int | XMax,
|  | unsigned int | YMin,
|  | unsigned int | YMax,
|  | unsigned int | ZMin,
|  | unsigned int | ZMax,
|  | std::istream & | is )
| protected

## ◆ GetBufferLength()

unsigned long gdcm::RLECodec::GetBufferLength | ( |  | ) | const
| inline

## ◆ GetHeaderInfo()

bool gdcm::RLECodec::GetHeaderInfo | ( | std::istream & | is,
|  | TransferSyntax & | ts )
| overridevirtual

Reimplemented from gdcm::ImageCodec.

## ◆ IsFrameEncoder()

bool gdcm::RLECodec::IsFrameEncoder | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ IsRowEncoder()

bool gdcm::RLECodec::IsRowEncoder | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ SetBufferLength()

void gdcm::RLECodec::SetBufferLength | ( | unsigned long | l | ) |
| inline

## ◆ SetLength()

void gdcm::RLECodec::SetLength | ( | unsigned long | l | ) |
| inline

## ◆ StartEncode()

bool gdcm::RLECodec::StartEncode | ( | std::ostream & |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ StopEncode()

bool gdcm::RLECodec::StopEncode | ( | std::ostream & |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## Friends And Related Symbol Documentation

## ◆ ImageRegionReader

friend class ImageRegionReader
| friend

References ImageRegionReader.

Referenced by ImageRegionReader.

The documentation for this class was generated from the following file:

- gdcmRLECodec.h